# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from reapp_msgs/SolderGoal.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg
import sensor_msgs.msg

class SolderGoal(genpy.Message):
  _md5sum = "02b5350dc5ce203b27324de2b584866e"
  _type = "reapp_msgs/SolderGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# pre heating time of the solder
float32 pre_heating_time

# residual heating time of the solder
float32 residual_heating_time

# soldering temperature
sensor_msgs/Temperature temperature

# feeding time when soldering
float32 feeding_time

# feeding speed when soldering
float32 feeding_speed


================================================================================
MSG: sensor_msgs/Temperature
 # Single temperature reading.

 Header header           # timestamp is the time the temperature was measured
                         # frame_id is the location of the temperature reading

 float64 temperature     # Measurement of the Temperature in Degrees Celsius

 float64 variance        # 0 is interpreted as variance unknown
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  __slots__ = ['pre_heating_time','residual_heating_time','temperature','feeding_time','feeding_speed']
  _slot_types = ['float32','float32','sensor_msgs/Temperature','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pre_heating_time,residual_heating_time,temperature,feeding_time,feeding_speed

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SolderGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.pre_heating_time is None:
        self.pre_heating_time = 0.
      if self.residual_heating_time is None:
        self.residual_heating_time = 0.
      if self.temperature is None:
        self.temperature = sensor_msgs.msg.Temperature()
      if self.feeding_time is None:
        self.feeding_time = 0.
      if self.feeding_speed is None:
        self.feeding_speed = 0.
    else:
      self.pre_heating_time = 0.
      self.residual_heating_time = 0.
      self.temperature = sensor_msgs.msg.Temperature()
      self.feeding_time = 0.
      self.feeding_speed = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2f3I.pack(_x.pre_heating_time, _x.residual_heating_time, _x.temperature.header.seq, _x.temperature.header.stamp.secs, _x.temperature.header.stamp.nsecs))
      _x = self.temperature.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d2f.pack(_x.temperature.temperature, _x.temperature.variance, _x.feeding_time, _x.feeding_speed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.temperature is None:
        self.temperature = sensor_msgs.msg.Temperature()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.pre_heating_time, _x.residual_heating_time, _x.temperature.header.seq, _x.temperature.header.stamp.secs, _x.temperature.header.stamp.nsecs,) = _struct_2f3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.temperature.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.temperature.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.temperature.temperature, _x.temperature.variance, _x.feeding_time, _x.feeding_speed,) = _struct_2d2f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2f3I.pack(_x.pre_heating_time, _x.residual_heating_time, _x.temperature.header.seq, _x.temperature.header.stamp.secs, _x.temperature.header.stamp.nsecs))
      _x = self.temperature.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d2f.pack(_x.temperature.temperature, _x.temperature.variance, _x.feeding_time, _x.feeding_speed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.temperature is None:
        self.temperature = sensor_msgs.msg.Temperature()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.pre_heating_time, _x.residual_heating_time, _x.temperature.header.seq, _x.temperature.header.stamp.secs, _x.temperature.header.stamp.nsecs,) = _struct_2f3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.temperature.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.temperature.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.temperature.temperature, _x.temperature.variance, _x.feeding_time, _x.feeding_speed,) = _struct_2d2f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2f3I = struct.Struct("<2f3I")
_struct_2d2f = struct.Struct("<2d2f")
